class Iframe {
    constructor() {
        this.init();
    }

    init() {
        const app = document.querySelector(".app");
        app.classList.add('emp-app');
        const iframe = document.createElement("iframe");
        iframe.setAttribute('allow', 'clipboard-write *');
        iframe.classList.add('emp-iframe');
        let url = null;
        if (localStorage.getItem('refresh')) {
            const path = localStorage.getItem('route');
            if (path) {
                url = `${data.iframeUrl}${path}`;
            } else {
                url = data.iframeUrl;
            }
            localStorage.removeItem('refresh');
        }
        else {
            url = data.iframeUrl;
        }

        // Constructing the URL
        const srcUrl = new URL(url);
        srcUrl.searchParams.set('t', new Date().getTime());
        iframe.src = srcUrl.toString();
        app.appendChild(iframe);
        this.iframe = iframe;
    }

    sendMessage(message, targetOrigin = '*') {
        const domain = window.location.hostname;
        this.iframe.contentWindow.postMessage({message,domain}, targetOrigin);
    }

}

export default Iframe;
