<?php
namespace Send\Classes\Integrations\WooCommerce;
use Send;
use Send\Classes\Integrations\Integrations;
use Send\Classes\Integrations\WooCommerce\Components\WooOrders;
use Send\Classes\Integrations\WooCommerce\Components\WooProducts;

class WooCommerce extends Integrations
{
	private $wooProducts = null;
	private $wooOrders = null;
	public $sourceName = 'woocommerce';
	public $name = 'WooCommerce';
    private static $instance = null;

	function __construct()
	{
		$this->resetState();
	}
    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self();
        }
        return self::$instance;
    }


    public function resetState() {
		$this->pluginFile = 'woocommerce/woocommerce.php';
		if (!function_exists('is_plugin_active')) {
			require_once(ABSPATH . '/wp-admin/includes/plugin.php');
		}
		if (self::isPluginActive())
		{
//			$this->wooProducts = Module::instance()->get_component( 'WooProducts' );
//			$this->wooOrders = Module::instance()->get_component( 'WooOrders' );
			$this->active = true;
			parent::__construct($this->name);
		}
		if (isset($this->pluginData)) {
			$this->pluginData['logoPath'] = plugins_url( '/app/Assets/images/woo.svg', Send::$pluginDir );
		}
	}

	public static function isPluginActive() {
		return is_plugin_active('woocommerce/woocommerce.php');
	}

	public function onPluginActivation() {
		if ( static::isPluginActive() ) {
			Module::instance()->get_component( 'WooOrders' )->sync();
			Module::instance()->get_component( 'WooProducts' )->sync();
		}

//		if (isset($this->wooOrders)) {
//			error_log('WooCommerce Logger: Orders sync started');
//			$this->wooOrders->sync();
//		} else {
//			error_log('WooCommerce Logger: Orders sync failed');
//		}
//		if (isset($this->wooProducts)) {
//			$this->wooProducts->sync();
//		} else {
//			error_log('WooCommerce Logger: Products sync failed');
//		}
	}
}
