<?php

namespace Send\Classes\Rest;

class Routes
{
	protected $routes = [];
	
	public function get($uri, $callback)
	{
		$this->addRoute('GET', $uri, $callback);
	}
	
	public function post($uri, $callback)
	{
		$this->addRoute('POST', $uri, $callback);
	}
	
	public function put($uri, $callback)
	{
		$this->addRoute('PUT', $uri, $callback);
	}
	
	public function delete($uri, $callback)
	{
		$this->addRoute('DELETE', $uri, $callback);
	}
	
	protected function addRoute($method, $uri, $callback)
	{
		$this->routes[] = [
			'method'   => $method,
			'uri'      => $uri,
			'callback' => $callback,
		];
	}
	
	public function register() {
		foreach ($this->routes as $route) {
			add_action('rest_api_init', function () use ($route) {
				register_rest_route('emp-plugin/v1', $route['uri'], array(
					'methods'  => $route['method'],
					'callback' => function ($request) use ($route) {
						// For POST, PUT, and DELETE requests, extract payload data
						$payload = $request->get_body_params();
						// Call the callback function with payload data
						return call_user_func($route['callback'], $payload);
					},
					'permission_callback' => '__return_true' 
				));
			});
		}
	}
}
