<?php
namespace Send\Classes\Traits;
use connect\Client;

trait Submission {

    private static function checkFormsInElements($formLocation) {
        global $wpdb;
        $sql = "
        SELECT p.ID
        FROM {$wpdb->posts} p
        INNER JOIN {$wpdb->postmeta} pm ON p.ID = pm.post_id
        WHERE p.post_type = 'elementor_library'
        AND p.post_status = 'publish'
        AND pm.meta_value LIKE %s
        ORDER BY p.post_date DESC
        LIMIT 1
    ";
        $pageId = $wpdb->get_var(
            $wpdb->prepare($sql, '%'.$formLocation.'%')
        );
        return $pageId;
    }
	public static function sendFormSubmissionData($payload,$source) {
		// from what page (name) this form was submitted:
		$pageUrl = $_SERVER['HTTP_REFERER'];
		error_log("form location from submit: ". $_POST['formLocation']);
		$formLocation = $_POST['formLocation'];
		if (empty($formLocation)) {
			error_log('Form location is required');
			return wp_json_encode(["status" => "error", "message" => "Form location is required"]);
		}
		$specialType = false;
        $pageId = url_to_postid($pageUrl);
        switch ($formLocation) {
		case 'popup':
		case 'header':
		case 'footer':
            $pageId = self::checkFormsInElements($formLocation);
			$specialType = true;
			break;
		default:
			break;
		}
		$pageName = basename(wp_parse_url($pageUrl, PHP_URL_PATH));
		error_log("Page URL: ".$pageUrl);
		error_log("Page name: ".$pageName);
		error_log("Page ID: ".$pageId);
		$data = [
			'siteUrl' => strval(CURRENT_HOST),
			'source' => ["method" => "form", "name" => $source],
			'page' => ["pageId" => strval($pageId), "name" => strval($pageName)],
			'specialType' => $specialType ? $formLocation : null,
			'formId' => strval($payload[0]), // Ensure formId is converted to string
			'formName' => $payload[1], // Assuming this is a string, no need for additional conversion
			'formFields' => $payload[2], // Assuming formFields is already in the correct format
		];
		$request_payload = [
			'siteUrl' => strval(CURRENT_HOST),
			"submissions" => [$data]
		];
        $client = new Client();
        return $client->make_request('POST', API_ENDPOINT . '/submissions', $request_payload, [], false, '');
	}
}
