<?php

namespace Send\App\Classes;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

use connect\Module_Base; //TODO: move to somewhere common

/**
 * class Modules_Manager
 **/
final class Modules_Manager {
	private $modules = [];

	public function __construct() {
		$modules = [
			'WooCommerce' => 'Send\Classes\Integrations\WooCommerce\Module'
		];

		foreach ( $modules as $module_name => $class_name ) {
			// TODO: once the naming is sorted-out, this code can be used:
//			$class_name = str_replace( '-', ' ', $module_name );
//			$class_name = str_replace( ' ', '', ucwords( $class_name ) );
//			$class_name = __NAMESPACE__ . '\\Modules\\' . $class_name . '\Module';

			/** @var Module_Base $class_name */
			if ( $class_name::is_active() ) {
				$this->modules[ $module_name ] = $class_name::instance();
			}
		}
	}

	public function get_modules( $module_name ) {
		if ( $module_name ) {
			if ( isset( $this->modules[ $module_name ] ) ) {
				return $this->modules[ $module_name ];
			}

			return null;
		}

		return $this->modules;
	}
}

new Modules_Manager();