<?php

namespace connect;

use connect\classes\data;

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

/**
 * Class Module
 */
class Module extends Module_Base
{

    /**
     * Get module name.
     * Retrieve the module name.
     * @access public
     * @return string Module name.
     */
    public function get_name()
    {
        return 'connect';
    }

    /**
     * component_list
     * @return string[]
     */
    public static function component_list(): array
    {
        return [
            'Handler',
        ];
    }

    /**
     * routes_list
     * @return string[]
     */
    public static function routes_list(): array
    {
        return [
            'Authorize',
            'Disconnect',
            'Deactivate',
            'Deactivate_And_Disconnect',
        ];
    }

    public static function is_connected(): bool
    {
        return !!data::get_access_token();
    }

    public function __construct()
    {
        $this->register_components();
        $this->register_routes();
    }
}
