<?php

namespace Custom\Sniffs\FileNaming;

use PHP_CodeSniffer\Sniffs\Sniff;
use PHP_CodeSniffer\Files\File;

class CapitalLetterClassFileNameSniff implements Sniff
{
	public function register()
	{
		return [T_OPEN_TAG];
	}
	
	public function process(File $phpcsFile, $stackPtr)
	{
		$fileName = $phpcsFile->getFilename();
		$basename = basename($fileName);
		
		// Check if the file name starts with a capital letter.
		if ( ! preg_match('/^[A-Z]/', $basename)) {
			$error = 'Class file name "%s" should start with a capital letter';
			$data  = [$basename];
			$phpcsFile->addError($error, $stackPtr, 'NotCapital', $data);
		}
	}
}
