<?php

use Send\Classes\Rest\Routes;

it('can add routes', function () {
	// Create an instance of the Routes class
	$routes = new Routes();

	// Add routes
	$routes->get('/test', function () {
		return 'GET request';
	});

	$routes->post('/test', function ($data) {
		return 'POST request with payload: ' . wp_json_encode($data);
	});

	// Retrieve the added routes using reflection
	$reflectionClass = new ReflectionClass($routes);
	$property = $reflectionClass->getProperty('routes');
	$property->setAccessible(true);
	$addedRoutes = $property->getValue($routes);

	// Verify the routes were added correctly
	expect(count($addedRoutes))->toBe(2);
	expect($addedRoutes[0]['method'])->toBe('GET');
	expect($addedRoutes[0]['uri'])->toBe('/test');
	expect($addedRoutes[1]['method'])->toBe('POST');
	expect($addedRoutes[1]['uri'])->toBe('/test');
});
